var db = window.localStorage;
$.ui.useOSThemes=false;        
$.ui.backButtonText = "Atrás";
/* This function runs when the body is loaded.*/
var init = function (){
    $.ui.launch();
    //Evento de boton atrás Android/WP
    document.addEventListener('backbutton', onBackKeyDown, false);
    document.addEventListener('deviceready', onDeviceReady, false);
    $("#dtBox").DateTimePicker({
        dateTimeFormat: "dd/MM/yyyy hh:mm:ss AA",
        dateSeparator:"/",
        maxDateTime: null,
        minDateTime: null
    });
    var instruciones = db.getItem('instruciones');
    //Intrucciones
    if(!instruciones){
        show_instructions();
    }
};
document.addEventListener("DOMContentLoaded", init, false);
function show_instructions(){
    $('body').append('<div onclick="remove_instructions();" id="div_instru"><img src="image/instrucciones.png" id="instrucciones"/></div>');
}
function remove_instructions(){
    $('#div_instru').remove();
    db.setItem('instruciones', true);
}
function show_coment_form(){
   $.ui.showModal('frm-comentarios');
}
/** Callback del boton atras, retrocede o cierra la app */
function onBackKeyDown(){
    if(!$.ui.hideModal())
    {
        $('#afui').popup({title:'YoAlerto',message:'Desea cerrar la app?',cancelText:'No',cancelCallback:function(){volver_mapa()},doneText: "Si",doneCallback:function(){navigator.app.exitApp()},cancelOnly:false});
    }
}
/** Crea el script de maps */
function cargar_mapa(){
    var connection = checkConnection();
    if(connection){
        // Se crea el script de gmaps
        var jsmap = document.createElement('script');
        jsmap.src = 'js/maps.js';
        document.body.appendChild(jsmap);
    }
}
/**
* Verifica si el dispositivo tiene conexion
* @return {Boolean} true si se posee una conexion o false en caso contrario
*/
var checkConnection = function(){
    try{
        var networkState = navigator.connection.type;
        var states = {};
        states[Connection.UNKNOWN]  = 'Unknown connection';
        states[Connection.ETHERNET] = 'Ethernet connection';
        states[Connection.WIFI]     = 'WiFi connection';
        states[Connection.CELL_2G]  = 'Cell 2G connection';
        states[Connection.CELL_3G]  = 'Cell 3G connection';
        states[Connection.CELL_4G]  = 'Cell 4G connection';
        states[Connection.CELL]     = 'Cell generic connection';
        states[Connection.NONE]     = 'No network connection';
        if (networkState != Connection.NONE && networkState != Connection.UNKNOWN){
            return true;
        }
        else{
            var mensaje = '<div style="text-align:center;margin-top:40%;"><p>Verifica tu conexión a internet: ';mensaje+=states[networkState];mensaje+='</p><a class="button" href="#" onclick="cargar_mapa();">Intenta de nuevo</a></div>';
            $('#map_canvas').html(mensaje);
            return false;
        }
    }
    catch(e){
        alert(e);
    }
};
        
/** Muestra el formulario de creacion de denuncia */
function mostrar_frm_denuncia(title, category){
    $.ui.hideModal();
    setTimeout(function(){
        $.ui.showModal('frm-denuncia');
        $('#categoria-denuncia').html(title);
        agregar_header(category);
        $('#str_categoria').val(title);
        $('#txt_categoria').val(category);
        //$('#txt_fecha').val();
        setTimeout(function(){
            $('#txt_descripcion').focus();
        },301)
    },300);
}
/** */
function mostrar_div_nuevo_lugar(){
    $.ui.hideModal();
    setTimeout(function(){
        $.ui.showModal('frm-add-lugar');
        $('#modalHeader').css('display','none');
        $('#afui #afui_modal').css('background','none');
        ocultar_botones_mapa();
    },300);
}
/** */
function ocultar_botones_mapa(){
    $('.btn_map').css('display','none');
}
/** */
function volver_mapa(){
    $.ui.hideModal();
    $('.btn_map').css('display','block');
}
/** */
function volver_fondo(){
    volver_mapa();
    setTimeout(function(){
        $('#afui #afui_modal').css('background','url("image/divisor_negro_con_alpha-01.png")');
    },300);
}

function ver_menu(menu){
    switch(menu){
        case 1:
            $('#lista-dias').toggle('fast');
            $('#lista-filtro').hide('fast');
            break;
        case 2:
            $('#lista-filtro').toggle('fast');
            $('#lista-dias').hide('fast');
            break;            
    }
}
/** limpia el formulario de crear denuncias */
function limpiar_frm(){
    volver_mapa();
    document.getElementById('frm_denuncia').reset();
    var img = $('#largeImage');
    img.css('display','none');
    img.attr('src', '');
    img_url = null;
}

/** Limpia el formulario de comnetarios de la app */
function limpiar_cmt_frm(){
    volver_mapa();
    document.getElementById('frm_comentarios').reset();
}
/** Agrega una clase al header para mostrar su respectiva imagen */
function agregar_header(category){
    var clase = '';
    switch(category){
        case 1:
            clase = 'header-hurto-per';
            break;
        case 2:
            clase = 'header-hurto-resi';
            break;
        case 3:
            clase = 'header-hurto-vehi';
            break;
        case 4:
            clase = 'header-hurto-comer';
            break;
        case 5:
            clase = 'header-homicidio';
            break;
        case 6:
            clase = 'header-lesiones';
            break;
        case 7:
            clase = 'header-vandalismo';
            break;
        case 8:
            clase = 'header-microtrafico';
            break;
        case 9:
            clase = 'header-delito-sexual';
        break;
        case 10:
            clase = 'header-matoneo';
        break;
        case 11:
            clase = 'header-violencia-intrafamiliar';
        break;
    }
    var header = document.getElementById('header-img');
    header.className = clase;
}

/** Enviar la denuncia */
var img_url;
function enviar_denuncia(){
    var fecha = $('#txt_fecha').val();
    if(fecha!= null && fecha != ''){
    var descripcion = $('#txt_descripcion').val(),categoria = $('#txt_categoria').val(),strCategoria= $('#str_categoria').val(),map=$('#map_canvas').gmaps(), latlgn = map.getCenter(), lugar = latlgn.toString();
        if(longitud_texto(descripcion)){
            $.ui.showMask('Guardando');
            //Si se eligió una imagen
            if(img_url!=null){
                enviar_denuncia_con_imagen(latlgn,map,descripcion,fecha,categoria,strCategoria,lugar);
            }
            else{
                $.ajax({
                    type:'post',
                    url:SITE+'denuncia/postnuevadenuncia',
                    data:{descripcion:descripcion,fecha:fecha,categoria:categoria,lugar:lugar},
                    success: function(data){
                        limpiar_frm();
                        placeMarker(data, latlgn, map, categoria,strCategoria,descripcion,fecha,null);
                        //Filtro de 5 por día
                        var cantidad = denuncias_dia() + 1;
                        db.setItem('denuncias_dia',cantidad);
                    },
                    error: function(xhr, status, error){
                        $('#afui').popup('No se pudo guardar tu denuncia: '+error);
                    },
                    complete: function(){
                        $.ui.hideMask();
                    }
                });
            }
        }
    }
    else{
        $('#afui').popup('Ingrese la fecha de los hechos.');
    }
}
/** */
function enviar_denuncia_con_imagen(latlgn,map,descripcion,fecha,categoria,strCategoria,lugar){
    var url=encodeURI(URL_DENUNCIA_IMG);
    var options = new FileUploadOptions();
    options.fileKey="file";
    options.fileName=img_url.substr(img_url.lastIndexOf('/')+1)+'.jpeg';
    options.mimeType="image/jpeg";

    var params = new Object();
    params.descripcion = descripcion;
    params.fecha = fecha;
    params.categoria = categoria;
    params.lugar = lugar;
    options.params = params;
    options.chunkedMode = false;

    var ft = new FileTransfer();
    ft.upload(img_url, url,
        function(s){//succes
            $.ui.hideMask();
            limpiar_frm();
            placeMarker(latlgn, map, categoria,strCategoria,descripcion,fecha,s.response);
        },        
        function(f)//fail
        {
            $.ui.hideMask();
            $('#afui').popup("Ocurrió un error al subir la imagen: "+error.code);
        },
        options);
}
/** */
function enviar_comentario(){
    var email = $('#txt_cmt_email').val(), descripcion = $('#txt_cmt_descripcion').val();
        if(descripcion!=''){
        if(longitud_texto(descripcion))
        {
            $.ui.showMask('Enviando');
            $.ajax({
                url:SITE+'denuncia/postcrearcomentarioapp',
                type:'post',
                data:{email:email,descripcion:descripcion},
                success:function (data){if(data){$('#afui').popup('Tu comentario se ha agregado y sera revisado por los desarrolladores');limpiar_cmt_frm();}},
                error: function (xhr,status,error){$('#afui').popup('No se pudo enviar tu comentario: '+error);},
                complete: function (){ $.ui.hideMask();}
            });
        }
    }
    else{$('#afui').popup('Ingrese la descripción de su comentario')}
}
function longitud_texto(text){ 
    var largo = text.length;
    if(largo<=250){
        return true;
    }
    else{
        $('#afui').popup('El texto de la descripción no debe pasar los 250 caracteres, tiene: '+largo);
        return false;
    }
}
/** Abre las opciones para obtener una imagen */
function iniciarCamara(){
    $("#afui").actionsheet([
        {text:'Tomar Foto',cssClasses:'red',handler:
            function(){capturePhoto();}
        },
        {text:'Desde el album de fotos',cssClasses:'',handler:
            function(){getPhoto(navigator.camera.PictureSourceType.PHOTOLIBRARY);}
        }
    ]);
}
/** Muestra la galeria para elegir la imagen */
function getPhoto(source){
    navigator.camera.getPicture(onPhotoURISuccess,onImgFail,{quality:50,destinationType:navigator.camera.DestinationType.FILE_URI,sourceType:source,targetWidth:400});
}
/** Lanza la app de la camara para capturar la imagen onPhotoDataSuccess*/
function capturePhoto(){
    navigator.camera.getPicture(onPhotoURISuccess,onImgFail,{quality:50,destinationType:navigator.camera.DestinationType.FILE_URI,targetWidth:400,saveToPhotoAlbum:true});
}
function onImgFail(message){
    $('#afui').popup('No se pudo obtener la foto: ' + message);
}
function onPhotoURISuccess(imageURI){
    var img = document.getElementById('largeImage');
    img.style.display = 'block';
    img.src = imageURI;
    if(imageURI.substring(0,21)=="content://com.android") {
        photo_split=imageURI.split("%3A");
        imageURI="content://media/external/images/media/"+photo_split[1];
    }
    img_url = imageURI;
}
/** Cambia la cantidad de dias en que se desea saber las denuncias */
var dias_consulta = 30;
function set_dias(cantidad){
    dias_consulta = cantidad;
    for (var i = 0, len = markers.length; i < len; i++){
        markers[i].setMap(null);
    }
    markers = [];
    $('#lista-dias>li>a.filtro').removeClass('check');
    $('#dias_'+cantidad).addClass('check');
    obtener_denuncias();
    $('#map_canvas').gmaps().setZoom(12);
}
/** Obtener denuncias anteriores */
function obtener_denuncias(){
    var dias = dias_consulta;
    $.ui.showMask('Obteniendo');
    $.ajax({
        type:'post',
        data: {dias:dias},
        url:SITE+'denuncia/postobtenerdenuncias',
        success:function(data){
            var map = $('#map_canvas').gmaps();
            if(data.length>20){
                 $(data).each(function(d){
                     var id= this.id,lugar = this.lugar,categoria = this.categoria, strCategoria=this.strCategoria,descripcion = this.descripcion, fecha = this.fecha, foto = this.foto;
                     placeMarker(id,lugar,map,categoria,strCategoria,descripcion,fecha,foto);
                 });
            }
            else{
                var i = 0;
                $(data).each(function(d){
                    var id= this.id,lugar = this.lugar,categoria = this.categoria, strCategoria=this.strCategoria,descripcion = this.descripcion, fecha = this.fecha, foto = this.foto;
                    setTimeout(function() {
                      addAnimatedMarker(id,lugar,map,categoria,strCategoria,descripcion,fecha,foto);
                    }, i++ * 200);
                });
            }
        },
        error:function(xhr, status, error){
            $('#afui').popup('No se pudieron obtener las denuncias: ' + error);
        },
        complete:function(){$.ui.hideMask();}
    });
}
/** Guarda el lugar frecuente en dispositivo */
function Lugar(nombre, centro, radio){
    this.nombre = nombre;
    this.centro = centro;
    this.radio = radio;
}
/** Guarda el lugar frecuente agregado */
function guardar_sitio(){
    var nombre = $('#site_name').val();
    if(nombre != ''){
        volver_mapa();
        if(cityCircle!=null){cityCircle.setMap(null);}
        var map = $('#map_canvas').gmaps(), latlgn = map.getCenter(), strlatlgn = latlgn.toString();
        var sitio = new Lugar(
            nombre,
            strlatlgn,
            300
        );
        //ERROR
        var lugares = db.getItem('lugares_frecuentes'), obj;
        if(lugares!=null){obj=JSON.parse(lugares)}
        else{obj=[]}

        obj.push(sitio);

        var jsonStr = JSON.stringify(obj);
        db.setItem('lugares_frecuentes',jsonStr);
        $('#afui').popup({title:nombre,message:'Tu lugar ha sido agregado, ahora puedes verificarlo antes de desplazarte.',cancelText:'OK',cancelOnly: true});
        addCircle(map, latlgn, sitio.radio);
        $('#site_name').val('');
    }
    else{
        $('#afui').popup({title:'Nuevo Lugar',message:'Asignale un nombre a tu lugar para agregarlo.',cancelText:'Aceptar',cancelOnly: true});
    }
}

/** Se agrega la denuncia a abuso de contenido*/
function reportar_abuso(denuncia){
    $.ajax({
        url: SITE+'denuncia/PostReporteAbuso',
        type: 'post',
        data: {id: denuncia},
        success: function(){$('#afui').popup({title:'YoAlerto',message:'El equipo de YoAlerto revisará esta denuncia.',cancelText:'OK',cancelOnly: true})},
        error: function(){$('#afui').popup({title:'Error',message:'No se pudo reportar esta denuncia.',cancelText:'Aceptar',cancelOnly: true})}
    });
}

//<<Implementación de Google Analytics
var gaPlugin;

function onDeviceReady() {
    gaPlugin = window.plugins.gaPlugin;
    gaPlugin.init(successHandler, errorHandler, "UA-57340663-1", 10);
    cargar_mapa();
}

function successHandler (result) {
    //alert('successHandler - '+result);
    console.log('successHandler: '+result);
}

function errorHandler (error) {
    //alert('errorHandler - '+error);
    console.log('errorHandler: '+error);
}